package cn.jisol.game.actions.onhook;

import cfg.TB.TbGRole;
import cn.hutool.core.lang.UUID;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.RandomUtil;
import cn.jisol.game.actions.GActionEnum;
import cn.jisol.game.data.GlobalIds;
import cn.jisol.game.data.TD;
import cn.jisol.game.network.client.GClient;
import cn.jisol.game.proto.GOnHookMessage;
import cn.jisol.ngame.actions.core.NAction;
import cn.jisol.ngame.actions.core.NActionMethod;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;
import java.util.concurrent.ConcurrentHashMap;

//无尽模式
@NAction
public class GOnHookAction {

    //生成的宠物列表
    public static Map<Long,Map<String, GOnHookMessage.GOnHookPet>> PETS = new HashMap<>();

    //生成宠物 返回生成好的列表
    @NActionMethod(GActionEnum.MODE_ON_HOOK_SPAWN_PET)
    public static GOnHookMessage.GOnHookPets onSpawnPet(GClient client){

        //获取玩家生成的宠物
        Map<String, GOnHookMessage.GOnHookPet> pets = PETS.get(client.player.getPlayerId());

        //如果没有则生成类
        if(Objects.isNull(pets)){
            PETS.put(client.player.getPlayerId(),pets = new HashMap<>());
        }

        //获取可生成的最大数量
        int max = Integer.parseInt(TD.DATA.getTbGOnHookGlobal().get(GlobalIds.MODE_ON_HOOK_SPAWN_NUM).args);

        //获取配置表全部宠物
        ArrayList<TbGRole> tdPets = TD.DATA.getTbGRole().getDataList();

        //如果小于最大数量则生成
        while (pets.size() < max){

            //目前随机生成宠物
            GOnHookMessage.GOnHookPet hookPet = GOnHookMessage.GOnHookPet.newBuilder()
                    //生成唯一Id
                    .setKey(RandomUtil.randomString(8))
                    //随机取配置表宠物中的宠物
                    .setPetTbId(tdPets.get(RandomUtil.randomInt(0, tdPets.size() - 1)).id)
                    .build();

            //添加到宠物列表中
            pets.put(hookPet.getKey(),hookPet);

        }

        //返回生成好的宠物
        return GOnHookMessage.GOnHookPets.newBuilder().addAllPets(pets.values()).build();
    }

}
